# BFBCompiler

Un compilador construído con Flex y Bison.

## Requerimientos

Para construir el compilador, se requieren las siguientes dependencias:

## Tabla de contenidos
* [Requisitos](#requisitos)
* [Compilación](#compilación)
* [Ejecución](#ejecución)
* [Testeos](#tests)

## Requisitos <a name="requisitos"></a>

Debe instalar

- [Bison v3.8.2](https://www.gnu.org/software/bison/)
- [CMake v3.22.2](https://cmake.org/)
- [Flex v2.6.4](https://github.com/westes/flex)
- [GCC v11.1.0](https://gcc.gnu.org/)
- [Make v4.3](https://www.gnu.org/software/make/)

Estos se encuentran disponibles en el repositorio de la vasta mayoría de distribuciones de Linux/macOS.

Si en lugar de trabajar con un entorno _Linux_, se está construyendo el proyecto sobre un entorno _Microsoft Windows_, se debe instalar _Microsoft Visual Studio 2022_ con las extensiones para desarrollar aplicaciones en _C/C++_, así como también las herramientas requeridas, con excepción del compilador _GCC_ y la herramienta _Make_.

## Compilación <a name="compilación"></a>

En Linux, para compilar todos los archivos, se debe ejecutar el script `compile.sh` (desde la carpeta raíz del proyecto). 

En un entorno _Microsoft Windows_, en cambio, debe correr `cmake -S . -B bin` y se deberá abrir la solución generada `bin/Compiler.sln` con el IDE _Microsoft Visual Studio 2022_.

## Ejecución <a name="ejecución"></a>

Ahora, usted podrá pasarle un programa haciendo:

```bash
./run.sh ${PROGRAM}
```

o también podría directamente escribir el programa:

```bash
./run.sh "fun x = x^2;"
```

## Testeos <a name="tests"></a>

Puede correrlos con:

```bash
ctest --test-dir bin
```

# Autores
- Barmasch, Juan Martín (61033)
- Bellver, Ezequiel (61268)
- Lo Coco, Santiago (61301)
